﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace ButtonAutoComplete
{
    
    public partial class ButtonEditExt : ButtonEdit
    {
        AutoComplete autocomplete = new AutoComplete();

        ButtonEditChildButton buttonEditChildButton1 = new ButtonEditChildButton();
        public ButtonEditExt()
        {
            InitializeComponent();
            this.ButtonStyle = Syncfusion.Windows.Forms.ButtonAppearance.Metro;
            this.buttonEditChildButton1.MetroColor = Color.LightGray;
            this.buttonEditChildButton1.PreferredWidth += 10;
            this.Buttons.Add(this.buttonEditChildButton1);
            this.Controls.Add(this.buttonEditChildButton1);
            this.TextChanged += new EventHandler(ButtonEditExt_TextChanged);
            this.autocomplete.ShowColumnHeader = false;
            this.UseVisualStyle = true;
            this.autocomplete.Style = AutoCompleteStyle.Metro;
            this.buttonEditChildButton1.UseVisualStyle = true;
            this.buttonEditChildButton1.Click += new EventHandler(buttonEditChildButton1_Click);
        }

        void ButtonEditExt_TextChanged(object sender, EventArgs e)
        {
            this.autocomplete.ActiveFocusControl = this.TextBox;
            //To show the autoCompletePopup
            this.autocomplete.ProcessAutoComplete(this.TextBox.Text, string.Empty, Point.Empty);
        }



        void buttonEditChildButton1_Click(object sender, EventArgs e)
        {
            //this.autocomplete.Style = AutoCompleteStyle.Metro;
            this.autocomplete.ActiveFocusControl = this.TextBox;
            //To show the autoCompletePopup
            this.autocomplete.ProcessAutoComplete(this.TextBox.Text, string.Empty, Point.Empty);
            this.autocomplete.ActiveFocusControl = null;
        }

        private object m_DataSource;
        /// <summary>
        /// Get/sets the DataSource for the ButtonEditExt
        /// </summary>
        public object DataSource
        {
            get { return m_DataSource; }
            set
            {
                this.m_DataSource = value;
                //Change parent form of the UserControl
                this.autocomplete.ParentForm = this.ParentForm;
                this.autocomplete.DataSource = value;

                this.autocomplete.SetAutoComplete(this.TextBox, AutoCompleteModes.MultiSuggestExtended);
            }
        }
        private string displayMember = string.Empty;
        /// <summary>
        /// Get/Sets the DisplayMember for the ButtonEditExt
        /// </summary>
        public String DisplayMember
        {
            get { return displayMember; }
            set
            {
                this.displayMember = value;
                if(this.displayMember != string.Empty)
                    this.autocomplete.RefreshColumns();
                foreach(AutoCompleteDataColumnInfo column in this.autocomplete.Columns)
                {
                    if(column.ColumnName == value)
                    {
                        column.Visible = true;
                    }
                    else
                    {
                        column.Visible = false;
                    }
                }
            }
        }
    }
}
